#! /usr/bin/env python3

import sys
import game


address = "http://localhost:8000"
maxv = None


if len(sys.argv) >= 2:
    address = "http://" + sys.argv[1]
if len(sys.argv) >= 3:
    maxv = float(sys.argv[2])


if maxv is None or maxv < 0.001:
    maxv = None


if __name__ == "__main__":

    g = game.Game()

    snap = g.start()
    ml, mu, mr = 0, 0, 0
    while True:  # Magical constants were determined by rigorous simulations
        land = snap.predict_landing()
        #print(land)
        if land.x < land.l and (maxv is None or maxv - snap.vx > 0.25):
            mr = 1
        else:
            mr = 0
        if land.x > land.r and (maxv is None or maxv - -snap.vx > 0.25):
            ml = 1
        else:
            ml = 0
        #mr = 1 if land.x < land.l else 0
        #ml = 1 if land.x > land.r else 0
        # We _never_ want to fly upwards
        if snap.vy > -2.0 or -snap.vy < snap.y / 5:
            mu = 0
        else:
            mu = 1
        try:
            snap = g.control(ml, mr, mu)
        except RuntimeError as re:
            print(re)
            break
        if maxv is not None and abs(snap.vx) > maxv:
            print("Welp, |{}| > {}".format(snap.vx, maxv))
        #print("{:.2f} {:.2f} {:.2f} {:.2f}".format(snap.x, snap.y, snap.vx, snap.vy))
        print(ml, mu, mr)
