#! /usr/bin/env python3

import os
import requests
import game
import sys
from bottle import route, run, static_file, request

address = "http://localhost:8000"

if len(sys.argv) > 1:
    address = "http://" + sys.argv[1]
print("Connecting to {}".format(address))


@route("/start")
def start():
    lines = requests.get(address + "/start").content.decode().split("\n")
    snap = game.Snapshot.from_response_lines(lines, game.Game())
    data = snap.to_json()
    data["id"] = lines[0].strip()
    return data


@route("/stav")
def stav():
    lines = requests.get(address + "/stav",
                         params={
                             "id": request.query["id"],
                             "nahoru": request.query["nahoru"],
                             "doleva": request.query["doleva"],
                             "doprava": request.query["doprava"]
                         }).content.decode().split("\n")
    result = lines[0].strip()
    if result in {"Zdar!", "Krach!"}:
        return {"result": result}
    snap = game.Snapshot.from_response_lines(lines, game.Game())
    return snap.to_json()


@route("/<path:path>")
def statics(path):
    return static_file(path, root=os.path.dirname(__file__))


run(host="localhost", port=8800)
